/* tmne1r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static float c_b14 = 1.f;

int main(void)
{
    /* Initialized data */
    static float fe = 1e-7f;
    static float xe[2] = { 1e-8f,1e-8f };
    static float ge[2] = { .001f,.001f };
    static float up[9] = { 5.f,.7f,.3f,500.f,600.f,0.f,0.f,10.f,1.f };
    static int i0[2] = { 1,1 };
    static int n = 2;
    static float x[2] = { -3.f,1.f };

    /* Local variables */
    static int ierr;
    extern int mne1r_c(float *, float *, U_fp, float *, float *, int *,
                       int *, int *, float *, U_fp, float *, float *, float *);
    static float f, g[2];
    extern int conus_c();
    static float rm[4];
    extern int subcon_c();

    mne1r_c(&f, &fe, (U_fp)conus_c, g, ge, &ierr, i0, &n, rm, (U_fp)subcon_c,
            up, x, xe);

    printf("\n %13.7f %13.7f \n", x[0], x[1]);
    printf("\n %13.7f \n", f);
    printf("\n %13.7f %13.7f \n", g[0], g[1]);
    printf("\n %5i \n", ierr);
    printf("\n %9.3f \n", up[4]);
    return 0;
} /* main */

int conus_c(float *x, float *f, float *fe)
{
    /* Initialized data */
    static float a[2] = { 1.f,4.f };
    static float b[2] = { -2.f,6.f };

    static int i__;
    static float arg;

    /* Parameter adjustments */
    --x;

    /* Function Body */
    *f = 0.f;
    for (i__ = 1; i__ <= 2; ++i__) {
        arg = a[i__ - 1] * x[i__] - b[i__ - 1];
        *f += abs(arg);
/* L1: */
    }
    return 0;
} /* conus_c */

int subcon_c(float *x, float *g, float *ge, int *i0)
{
    /* Initialized data */
    static float a[2] = { 1.f,4.f };
    static float b[2] = { -2.f,6.f };

    /* Builtin functions */
    double r_sign(float *, float *);

    /* Local variables */
    static int i__;
    static float arg;

/*  BCET CYPAEHT - CONUS */
    /* Parameter adjustments */
    --i0;
    --ge;
    --g;
    --x;

    /* Function Body */
    for (i__ = 1; i__ <= 2; ++i__) {
        if (i0[i__] == 0) {
            goto L2;
        }
        arg = a[i__ - 1] * x[i__] - b[i__ - 1];
        g[i__] = (float)r_sign(&c_b14, &arg) * a[i__ - 1];
        goto L1;
L2:
        g[i__] = 0.f;
L1:
        ;
    }
    return 0;
} /* subcon_c */
